@import "./variable";
@import url('https://fonts.googleapis.com/css2?family=Noto+Sans+JP:wght@300;400;700&display=swap');

* {
	-webkit-box-sizing: border-box;
	-moz-box-sizing: border-box;
	box-sizing: border-box;
}

/*
 * -- BASE STYLES --
 * Most of these are inherited from Base, but I want to change a few.
 */

html {
	line-height: 1.8rem;
}

@media screen and (max-width: #{$sp}) {
	html {
		line-height: 1.8rem;
		font-size: 1rem;
	}
}

body {
	color: map-get($theme-colors, text);
	padding: 0;
	margin: 0;
	font-family: 'Noto Sans JP', sans-serif;
}

h1,
h2,
h3,
h4,
h5,
h6 {
	color: map-get($theme-colors, text);

	span {
		font-size: 90%;
		margin-left: 0.5rem;
	}
}

h1 {
	line-height: 3rem;
}

h3 {
	line-height: 2rem;
}

a {
	color: map-get($theme-colors, info);
}

label {
	color: map-get($theme-colors, primary);
}

li {
	padding: 0.5vw;
}

img {
	object-fit: contain;
}

/** Layout */
.pw-card {
	border-radius: 2px;
	padding: 1rem;

	display: flex;
	flex-direction: column;
}

/** Custom Styles */
.pw-is-right {
	text-align: right;
}

.pw-is-center {
	text-align: center;
}

.pw-is-radius {
	border-radius: 20px;
}

@media screen and (max-width: #{$sp}) {
	.pw-sp-rotate-90 {
		transform: rotate(90deg);
	}
}

/** item */

.pw-img-responsive {
	max-width: 100%;
	height: auto;
}

.pw-button-rainbow {
	border: none;
	padding: 1em;
	outline: none;
	color: white;
	text-transform: uppercase;
	font-weight: 900;
	font-style: 1.2em;
	letter-spacing: 0.2em;
	position: relative;
	z-index: 1;
	cursor: pointer;
	background: none;
	text-shadow: 3px 3px 10px rgba(0, 0, 0, 0.45);
	&:before,
	&:after {
		position: absolute;
		top: 50%;
		left: 50%;
		border-radius: 10em;
		transform: translateX(-50%) translateY(-50%);
		width: 105%;
		height: 105%;
		content: "";
		z-index: -2;
		background-size: 400% 400%;
		background: linear-gradient(60deg, #f79533, #f37055, #ef4e7b, #a166ab, #5073b8, #1098ad, #07b39b, #6fba82);
	}
	&:before {
		filter: blur(7px);
		transition: all 0.25s ease;
		animation: pulse 10s infinite ease;
	}
	&:after {
		filter: blur(0.3px);
	}
	&:hover {
		&:before {
			width: 115%;
			height: 115%;
		}
	}
}

.pw-square {
	width: 100%;
	position: relative;

	&:before {
		content: "";
		display: block;
		padding-top: 100%;
	}

	.pw-img-circle {
		border-radius: 50%;
		object-fit: cover;

		position: absolute;
		width: 95%;
		height: 95%;
		top: 0;
		left: 0;
		margin: auto;
	}
}

/** onegoma */
.onegoma {
	--balloon-padding: 8%; //ふきだし内の余白
	--balloon-padding-tail: 10%; //ふきだし内のちょんとした部分が付いている側の余白
	--character-margin-tail: -5%; //キャラクターとふきだしの間隔

	// ふきだしとキャラクターの位置関係をflexboxで操作
	// デフォルトは左にふきだし、右にキャラクター
	display: -webkit-box;
	display: -webkit-flex;
	display: -ms-flexbox;
	display: flex;
	display: -webkit-flex;
	display: -moz-flex;
	display: -ms-flex;
	display: -o-flex;
	-webkit-box-orient: horizontal;
	-webkit-box-direction: normal;
	-ms-flex-direction: row;
	flex-direction: row;
	-webkit-flex-wrap: nowrap;
	-ms-flex-wrap: nowrap;
	flex-wrap: nowrap;

	justify-content: center;
	align-items: center;

	// ふきだしとキャラクターの位置関係
	&.left {
		-webkit-box-orient: horizontal;
		-webkit-box-direction: reverse;
		-ms-flex-direction: row-reverse;
		flex-direction: row-reverse;

		.balloon:not(&[data-frame="boom"]) {
			padding-right: var(--balloon-padding);
			padding-left: var(--balloon-padding-tail);
		}
		.character {
			margin-right: var(--character-margin-tail);
			margin-left: 0;
		}

		svg,
		object {
			transform: scale(-1, 1);
		} // ふきだしやキャラクターを左右反転
	}
	&.bottom {
		-webkit-box-orient: vertical;
		-ms-flex-direction: column;
		flex-direction: column;
		.character {
			margin: 0;
			margin-top: var(--character-margin-tail);
		}
	}

	// **********
	// ふきだし
	.balloon {
		width: auto;
		margin: 10px;
		padding: var(--balloon-padding);
		padding-right: var(--balloon-padding-tail);
		font-size: 0.9rem;

		position: relative;
		z-index: 2;

		svg {
			width: 100%;
			height: 100%;
			position: absolute;
			left: 0px;
			top: 0px;
			z-index: -1;

			// ふきだしのデザイン
			& > * {
				fill: white;
			}
		}

		// ふきだし別スタイル
		&[data-frame="boom"] {
			padding: 15%;
			padding-top: 10%;
		}
		&[data-frame="thought"] {
			padding: 10%;
			padding-bottom: 15%;
		}
		&[data-frame="cloud"] {
			padding: 10%;
		}

		// ふきだしのデザインバリエーション
		&[data-type="blue"] {
			svg > * {
				fill: skyblue;
				stroke: transparent;
			}
		}
		&[data-type="gold"] {
			svg > * {
				fill: gold;
			}
		}
	}

	// **********
	// キャラクター
	.character {
		width: 25%;
		height: 25%;
		max-width: 250px;
		max-height: 250px;
		min-width: 100px;
		min-height: 100px;
		margin-left: var(--character-margin-tail);
		position: relative;
		text-align: center;

		object {
			width: 100%;
			// 			height: 100%;
			box-shadow: none;
			&.face,
			&.accessory {
				left: 0px;
				top: 0px;
				position: absolute;
			}
		}
	}
}

.cm {
	--character-margin-tail: 5%; //キャラクターとふきだしの間隔
	justify-content: flex-end;
	// **********
	// キャラクター
	.character {
		width: 5%;
	}
}

@import "./components/button";
@import "./components/input";

@import "./components/container";
@import "./components/section";

/** ***** Layout ***** */
@import "./layout/flex";
@import "./layout/position";
// @import "./layout/grid";
@import "./layout/space";
@import "./layout/size";

@import "./components/text";
@import "./components/bg";
